<!DOCTYPE html>
<html lang="en">
  <head>

    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <title>UI-Testing mit Cypress</title>

    <link rel="stylesheet" href="dist/reset.css">
    <link rel="stylesheet" href="dist/reveal.css">
    <link rel="stylesheet" href="dist/theme/white.css">

    <!-- Theme used for syntax highlighted code -->
    <link rel="stylesheet" href="plugin/highlight/monokai.css">

  </head>
  <body>

    <div class="reveal">

      <div class="slides">

        <footer style="position: absolute; bottom: 0; width: 100%; font-size: 2vh;">
          Presentation created in Markdown with <a href="https://revealjs.com/" target="_blank">Reveal.js</a>
        </footer>

        <section data-markdown data-separator="^\n---\n$" data-separator-vertical="^\n--\n$">

          <textarea data-template>

            ## UI-Testing mit Cypress

            ---

            ## Was ist Cypress?

            - Framework für das Testing von Web-Anwendungen
            - Open-Source
            - Ähnlich wie Selenium
            - Meiner Meinung nach deutlich besser, einfacher und flexibler

            ---

            ## Installation

            <code style="background: #dee; padding: 5px 15px; border-radius:4px;">
              npm install cypress --save-dev
            </code>

            ---

            ## Cypress Beispiele

            ![Cypress Beispiele](images/examples.PNG)

            ---

            ## Der erste Test

            ```typescript
            describe('UITest', async (): Promise<void> => {

              it('UITest', async (): Promise<void> => {

                cy.visit('http://localhost:8080');

                cy.contains('UI-Testing mit Cypress');

                cy.get("[data-cy=auswahl]").parent().click();
                cy.get(".v-menu__content").contains("Auswahl 3").click();

                cy.get('[data-cy=wert]').type('Hello World');

                cy.get('button#speichern').click();

                cy.get('[data-cy=result] tbody tr').each(($el) => {
                  cy.wrap($el).within(() => {
                    cy.get('td').eq(1).should('have.text', 'Hello World')
                  })
                })

              });

            });
            ```

            ---

            ## Mocking HTTP-Requests

            --

            ### Test

            ```typescript
            describe('Mocking', async (): Promise<void> => {

                beforeEach(() => {
                  cy.intercept('GET', 'http://localhost:58000/examples', { fixture: 'data.json' }).as('examples');
                });

                it('Mocking', async (): Promise<void> => {

                    cy.visit('http://localhost:8080');

                    cy.contains('UI-Testing mit Cypress');

                    cy.get('button#backend').click();

                    cy.wait(['@examples']);

                    cy.get('[data-cy=result] tbody tr').each(($el) => {
                        cy.wrap($el).within(() => {
                            cy.get('td').eq(1).should('have.text', 'Mocking Request')
                        })
                    })

                });

            });
            ```

            --

            ### data.json

            ```json
            [
              {
                "auswahl": "Auswahl 1",
                "wert": "Mocking Request"
              }
            ]
            ```

            ---

            ## Vue Components testen

            --

            ## Vue Component

            ```vue
            <template>
              <section>
                <h1 data-testid="title">👋 Hello {{ name }}!</h1>
                <p>This is your first component tested using browser-based component testing with Cypress + Vue ✌️🌲</p>
              </section>
            </template>

            <script lang="ts">
            import { Component, Prop, Vue } from 'vue-property-decorator';

            @Component
            export default class Greetings extends Vue {

              @Prop({default: 'world'})
              name!: string;

            }
            </script>
            ```

            --

            ## Component Test

            ```typescript
            /// <reference types="cypress" />
            import { mount } from '@cypress/vue'
            import Greetings from '@/components/Greetings.vue'

            describe('Greetings', () => {
              it('renders the component with a default name', () => {
                mount(Greetings)

                // now we can use any Cypress command to interact with the component
                // https://on.cypress.io/api
                cy.get('[data-testid=title]').should('exist').and('contain', 'Hello world')
              })

              it('renders the name passed in', () => {
                const name = 'Manuel'
                mount(Greetings, {
                  propsData: {
                    name
                  }
                })

                cy.get('[data-testid=title]').should('contain', `Hello ${name}`)
              })
            })
            ```

            ---

            ## UI-Test ausführen

            <code style="background: #dee; padding: 5px 15px; border-radius:4px;">
              cypress open
            </code>

            --

            ## Dashboard

            ![Cypress Dashboard](images/dashboard.PNG)

            --

            ## Ergebnis

            <img src="images/testresult.PNG" alt="Cypress Ergebnis" style="width: 75%; height: 75%;"/>

            ---

            ## Repository

            Das komplette Projekt inkl. Cypress UI-Tests steht auf Gitlab zur Verfügung.

            https://gitlab.com/fh-swf/fb-in/moderne_web-frameworks/uitesting_cypress

          </textarea>

        </section>

      </div>

    </div>

    <script src="dist/reveal.js"></script>
    <script src="plugin/notes/notes.js"></script>
    <script src="plugin/markdown/markdown.js"></script>
    <script src="plugin/highlight/highlight.js"></script>
    <script>
      // More info about initialization & config:
      // - https://revealjs.com/initialization/
      // - https://revealjs.com/config/
      Reveal.initialize({
        hash: true,

        // Learn about plugins: https://revealjs.com/plugins/
        plugins: [ RevealMarkdown, RevealHighlight, RevealNotes ]
      });
    </script>

  </body>
</html>
